Subject: Re: Ethernet issue on imx6

From: Alexander Stein <[email-masked]>
Date: Mon, 16 Oct 2023 16:41:50 +0200

Hi Miquel,

Am Montag, 16. Oktober 2023, 15:31:54 CEST schrieb Miquel Raynal:
> Hi Alexander,
> 
> Thanks a lot for your feedback.
> 
> > > switch to partitions #0, OK
> > > mmc1 is current device
> > > reading boot.scr
> > > 444 bytes read in 10 ms (43 KiB/s)
> > > ## Executing script at 20000000
> > > Booting from mmc ...
> > > reading zImage
> > > 9160016 bytes read in 462 ms (18.9 MiB/s)
> > > reading <board>.dtb
> > 
> > Which device tree is that?
> > 
> > > 40052 bytes read in 22 ms (1.7 MiB/s)
> > > boot device tree kernel ...
> > > Kernel image @ 0x12000000 [ 0x000000 - 0x8bc550 ]
> > > ## Flattened Device Tree blob at 18000000
> > > 
> > >    Booting using the fdt blob at 0x18000000
> > >    Using Device Tree in place at 18000000, end 1800cc73
> > > 
> > > Starting kernel ...
> > > 
> > > [    0.000000] Booting Linux on physical CPU 0x0
> > > [    0.000000] Linux version 6.5.0 (mraynal@xps-13)
> > > (arm-linux-gcc.br_real
> > > (Buildroot 2 020.08-14-ge5a2a90) 10.2.0, GNU ld (GNU Binutils) 2.34)
> > > #120
> > > SMP Thu Oct 12 18:10:20 CE ST 2023
> > > [    0.000000] CPU: ARMv7 Processor [412fc09a] revision 10 (ARMv7),
> > > cr=10c5387d [    0.000000] CPU: PIPT / VIPT nonaliasing data cache, VIPT
> > > aliasing instruction cache
> > > [    0.000000] OF: fdt: Machine model: TQ TQMa6Q
> > > on MBa6x
> > 
> > Your first mail mentions a custom board, but this indicates "TQMa6Q
> > on MBa6x", so which is it?
> 
> It's a custom carrier board with a TQMA6Q-AA module.

Could you please adjust the machine model to your mainboard if it is not a 
MBa6x? Thanks.
Which HW revision is this module? It should be printed in u-boot during start. 
Can you provide a full log?

> > Please note that there are two different module variants,
> > imx6qdl-tqma6a.dtsi and imx6qdl-tqma6b.dtsi. They deal with i.MX6's
> > ERR006687 differently. Package drop without any load somewhat indicates
> > this issue.
> 
> I've tried with and without the fsl,err006687-workaround-present DT
> property. It gets successfully parsed an I see the lower idle state
> being disabled under mach-imx. I've also tried just commenting out the
> registration of the cpuidle driver, just to be sure. I saw no
> difference.

fsl,err006687-workaround-present requires a specific HW workaround, see [1]. 
So this is not applicable on every module.

> By the way, we tried with a TQ eval board with this SoM and saw the same
> issue (not me, I don't have this board in hands). Don't you experience
> something similar? I went across a couple of people reporting similar
> issues with these modules but none of them reported how they fixed it
> (if they did). I tried two different images based on TQ's Github using
> v4.14.69 and v5.10 kernels.

Personally I've heard the first time about this issue. I never noticed 
something like this. Does this issue also appear when using TCP? Or is it an 
UDP only issue?

Best regards,
Alexander

[1] https://github.com/tq-systems/linux-tqmaxx/blob/TQMa8-fslc-5.10-2.1.x-imx/
arch/arm/boot/dts/imx6qdl-tqma6a.dtsi#L36-L48

-- 
TQ-Systems GmbH | Mühlstraße 2, Gut Delling | 82229 Seefeld, Germany
Amtsgericht München, HRB 105018
Geschäftsführer: Detlef Schneider, Rüdiger Stahl, Stefan Schneider
http://www.tq-group.com/